;Utility routines

 include "settings.inc"
 include "ti73.inc"
 include "equates.inc" 
 SEGMENT Main
 GLOBALS ON

getAppNameLen:
       ld b,0
$$:    ld a,(hl)
       or a
       ret z
       cp ' '
       ret z
       inc b
       inc hl
       jr $B

IPutS8Max:
       ld b,8
$$:    ld a,(hl)
       or a
       jr z,$F
       B_CALL PutC
       inc hl
       djnz $B
       ld a,' '
       B_CALL PutC
       ret
$$:    ld a,' '
       B_CALL PutC
       djnz $B
       ld a,' '
       B_CALL PutC
       ret

grayScreen:
       ld hl,saveSScreen
       B_CALL SaveDisp
       ld hl,saveSScreen
       ld d,01010101b
       ld c,64
grayScreenLoop:
       ld b,12
$$:    ld a,d
       and (hl)
       ld (hl),a
       inc hl
       djnz $B
       ld a,d
       rrca
       ld d,a
       dec c
       jr nz,grayScreenLoop
       ld hl,saveSScreen
       ld b,64
       B_CALL RestoreDisp
       ret

SoftKey:
       push hl
 	ld bc,51*256+7
	ld de,51*256+57
;	B_CALL DarkLine
	ld bc,7
	ld de,95*256+7
	B_CALL DarkLine
	ld bc,19*256+7
	ld de,19*256
	B_CALL DarkLine
	ld bc,38*256+7
	ld de,38*256
	B_CALL DarkLine
	ld bc,57*256+7
	ld de,57*256
	B_CALL DarkLine
	ld bc,76*256+7
	ld de,76*256
	B_CALL DarkLine
	ld hl,57*256+2
	ld (penCol),hl
	pop hl
	ld b,5
$$:	ld a,(penCol)
	ld c,a
	push bc
	call vputstring
	pop bc
	ld a,c
	add a,19
	ld (penCol),a
	djnz $B
       ret

DispHexArray:
       ld hl,2
       ld (curRow),hl
       ld b,14
       ld hl,header
$$:    ld a,(hl)
       call DispHexA
       inc hl
       djnz $B
       ret

VPutSAppCenter:
       push hl
       call SStringLen
       pop hl
       ld a,95
       sub c
       jr nc,$F
       xor a
$$:    srl a
       ld (penCol),a
VPutSApp:
       ld a,(hl)
       inc hl
       or a
       ret z
       B_CALL VPutMap
       jr VPutSApp

PutSApp:
       ld a,(hl)
       inc hl
       or a
       ret z
       B_CALL PutMap
       ld a,(curCol)
       inc a
       ld (curCol),a
       cp 16
       jr nz,PutSApp
       xor a
       ld (curCol),a
       ld a,(curRow)
       cp 7
       jr z,PutSApp
       inc a
       ld (curRow),a
       jr PutSApp

SStringLen:
       ld c,0
$$:    ld a,(hl)
       inc hl
       or a
       ret z
       push hl
       ld h,0
       ld l,a
       add hl,hl
       add hl,hl
       add hl,hl
       B_CALL SFont_Len
       ld a,b
       pop hl
       add a,c
       ld c,a
       jr $B

IPutS11:
       push hl
       push bc
       ld bc,0
       ld (curRow),bc
       ld b,8
$$:    ld a,(hl)
       or a
       jr z,$F
       inc hl
       B_CALL PutC
       djnz $B
$$:    pop bc
       pop hl
       ret

myLoadCIndPaged:
;       B_CALL LoadCIndPaged
inc_BHL:
       inc hl
inc_BHL_1:
       bit 7,h
       ret z
       inc b
       res 7,h
       set 6,h
       ret
myLoadDEIndPaged:
;       B_CALL LoadDEIndPaged
       jr inc_BHL
BHL_plus_DE:
       add hl,de
       jr inc_BHL_1

;Draws horizontal dotted line
;Input: bc = (x,y) coordinate of first point (lower left corner is (0,0))
;		   e = column to stop at
;Output: line drawn
FunkyLine:
	ld d,1
FunkyLine_Loop:
	B_CALL IPoint
	inc b
	inc b
	ld a,b
	cp e
	jp m,FunkyLine_Loop
	ret

vputstring:
	ld a,(hl)
	inc hl
	or a
	ret z
	B_CALL VPutMap
	jr vputstring

DispA:
	push hl
	ld c,-1
DispA_loop:
	inc c
	sub 10
	jr nc,DispA_loop
	add a,10
	push af
	ld a,c
	add a,'0'
	B_CALL VPutMap
	pop af
	add a,'0'
	B_CALL VPutMap
	pop hl
	ret

IGetKey:
       push ix
       push bc
       push de
       push hl
       res onInterrupt,(iy+onFlags)
       B_CALL GetKey
       pop hl
       pop de
       pop bc
	pop ix
       ret

IPutS:
       ld     a,(hl)
       inc    hl
       or     a
       ret    z
       call   IPutC
       jr     IPutS

IPutC:
       push   hl ;don't think these are necessary
       push   bc
       B_CALL PutC
       pop    bc
       pop    hl
       ret
       
 Var TempNum,2
GetHexA:
;lets user input an 8 bit number in hexadecimal
;prompt is at currow,curcol
;number is returned in a
	set curAble,(iy+curFlags)
	ld	b,2
	ld	hl,TempNum
getnumhloop:
   call IGetKey
	cp	2
	jp	nz,gnhnotback
	ld	a,b
	cp	2
	jp	z,gnhnotback
	ld	a,' '
   B_CALL PutMap
	ld	hl,curCol
	dec (hl)
	jp	GetHexA
gnhnotback:
	sub 142
	cp	10
	jp	c,gnhnumpressed
	sub 12
	cp	6
	jp	c,gnhletpressed
	jp	getnumhloop
gnhnumpressed:
	ld	(hl),a
	inc hl
	add a,48
	call IPutC
	djnz getnumhloop
	jp	gnhdone
gnhletpressed:
	add a,10
	ld	(hl),a
	inc hl
	add a,55
   call IPutC
	djnz getnumhloop
gnhdone:
	dec hl
	ld	b,(hl)
	dec hl
	ld	a,(hl)
	rlca
	rlca
	rlca
	rlca
	or	b
   res curAble,(iy+curFlags)
	ret

DispHexHL:
   push af
	push bc
	push de
	push hl
	push ix
   ld a,h
   call DispHexA
   ld a,l
   call DispHexA
	pop ix
	pop hl
	pop de
	pop bc
   pop af
   ret

DispHexA:
	push ix
	push af
   push hl
   push bc
   push af
   rrca
   rrca
   rrca
   rrca
   call dispha
   pop af
   call dispha
   pop bc
   pop hl
	pop af
	pop ix
   ret
dispha:
   and 15
   cp 10
   jp nc,dhlet
   add a,48
   jp dispdh
dhlet:
   add a,55
dispdh:
   call IPutC
   ret

;DialogBox
; Input
;  (H,L) = (y,x) upper left
;  (D,E) = (y,x) lower right
;H and l must be >= 1
;D must be <= 62
;E must be <= 93
;Text inside the box must be displayed manually
DialogBox:
	push hl
	push de
	dec h
	dec l
	inc d 
	inc d
	inc e
	inc e
	B_CALL EraseRectBorder
	pop de
	pop hl
	push hl
	push de
	B_CALL DrawRectBorderClear	
	pop de
	pop hl
	push hl
	push de
	inc d
	inc e
	B_CALL DrawRectBorder
	pop de
	pop hl
	ld	a,h
	xor 63 ;Adjust for funny IPoint coordinates
	ld	h,a 
	ld	a,d
	xor 63
	ld	b,l
	ld	c,h
	ld	d,0
	B_CALL IPoint ;(b,c) = (x,y xor 63) - upper left
	ld	b,e
	B_CALL IPoint
	inc b
	B_CALL IPoint
	dec c
	B_CALL IPoint
	ld	c,a
	dec c
	B_CALL IPoint
	ld	b,l
	B_CALL IPoint
	inc b
	B_CALL IPoint
	dec b
	inc c
	B_CALL IPoint
	ret

VStrLen:
	ld b,0
VStrLen_Loop:
	ld a,(hl)
	or a
	ret z
	push hl
	ld h,0
	ld l,a
	add hl,hl
	add hl,hl
	add hl,hl
	push bc
	B_CALL SFont_Len
	ld a,b
	pop bc
	pop hl
	inc hl
	add a,b
	ld b,a
	jr VStrLen_Loop

VEraseEOL:
	ld a,' '
	B_CALL VPutMap
	ld a,(penCol)
	cp c
	jp m,VEraseEOL
	ret

cmpstr:
       ld a,(de)
       cp (hl)
       ret nz
       or a
       ret z
       inc de
       inc hl
       jr cmpstr

cmpstrb:
       ld a,(de)
       cp (hl)
       ret nz
       inc de
       inc hl
       djnz cmpstrb
       xor a
       ret

putsb:
       push bc
       push hl
$$:    ld a,(hl)
       B_CALL PutC
       inc hl
       djnz $B
       pop hl
       pop bc
       ret
